aboutsummaryrefslogtreecommitdiff
path: root/libexec/rc/rc.d/zpool
diff options
context:
space:
mode:
Diffstat (limited to 'libexec/rc/rc.d/zpool')
-rwxr-xr-xlibexec/rc/rc.d/zpool9
1 files changed, 8 insertions, 1 deletions
diff --git a/libexec/rc/rc.d/zpool b/libexec/rc/rc.d/zpool
index f98693f2cb13..e73c2b7e5b73 100755
--- a/libexec/rc/rc.d/zpool
+++ b/libexec/rc/rc.d/zpool
@@ -22,7 +22,14 @@ zpool_start()
for cachefile in /etc/zfs/zpool.cache /boot/zfs/zpool.cache; do
if [ -r $cachefile ]; then
- zpool import -c $cachefile -a -N && break
+ zpool import -c $cachefile -a -N
+ if [ $? -ne 0 ]; then
+ echo "Import of zpool cache ${cachefile} failed," \
+ "will retry after root mount hold release"
+ root_hold_wait
+ zpool import -c $cachefile -a -N
+ fi
+ break
fi
done
}